unit FileMapReg;

interface

procedure Register;

implementation
uses
  Classes, DsgnIntf, Dialogs,
  asa_mmf, MemDumpView, MemoryViewer, FileMapSetupDlg;


{$R *.dcr}

type
  TFileMapEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure TFileMapEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: SetupFileMap(Component);
    1: if TasaMMF(Component).Active then
         ViewMemoryDump(TasaMMF(Component).Data, TasaMMF(Component).GetRealMapSize,
         TasaMMF(Component).ReadOnly );
  end;
end;

function TFileMapEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Setup dialog';
    1: Result := 'Memory Viewer';
  end;
end;

function TFileMapEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;
//
type
{ TMPFilenameProperty }

TMMFFileNameProperty = class(TStringProperty)
public
  procedure Edit; override;
  function GetAttributes: TPropertyAttributes; override;
end;

procedure TMMFFileNameProperty.Edit;
var
  FO: TOpenDialog;
begin
  FO := TOpenDialog.Create(nil);
  try
    FO.Filename := GetValue;
    FO.Filter := 'All files (*.*)|*.*';
    FO.HelpContext := 0;
    FO.Options := FO.Options + [ofShowHelp, ofPathMustExist,
                  ofFileMustExist];
    if FO.Execute then SetValue(FO.Filename);
  finally
    FO.Free;
  end;
end;

function TMMFFileNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paRevertable];
end;

//
procedure Register;
begin
  RegisterComponents('ASA', [TasaMMF]);
  //
  RegisterComponentEditor(TasaMMF, TFileMapEditor);
  RegisterPropertyEditor(TypeInfo(String),TasaMMF,'FileName',TMMFFileNameProperty);
  //
end;

end.
